//+------------------------------------------------------------------+
//|                                   FxCraft Trend Catcher Line.mq4 |
//|                                              http://fxcraft.biz/ |
//+------------------------------------------------------------------+
//|                                                                  |
//| Licence is available at:                                         |
//| http://fxcraft.biz/licence_free_indicator                        |
//| Licencja jest dostpna pod adresem:                              |
//| http://fxcraft.biz/licencja_darmowy_wskaznik                     |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "FxCraft"
#property link      "http://fxcraft.biz/"

#property indicator_chart_window

#property indicator_buffers 6
#property indicator_color1 RoyalBlue
#property indicator_color2 Red
#property indicator_color3 Gold
#property indicator_color4 RoyalBlue
#property indicator_color5 Red
#property indicator_color6 Gold

extern string I ="MA Settings";
extern int       ma_period_1=20;//70;
extern int       ma_period_2=30;//100;
extern int       ma_shift_1=0;
extern int       ma_shift_2=0;
extern string Ia ="Price 0-Close, 1-Open, 2-High, 3-Low, 4-Median, 5-Typical, 6-Weighted";
extern int       ma_price_1=0;
extern int       ma_price_2=0;
extern string Ib = "Method 0-SMA, 1-EMA, 2- SMMA, 3-LWMA";
extern int       ma_method_1=0;
extern int       ma_method_2=0;
extern string II = "Distance between averages";
extern int       deviation=2;//5;
extern string III ="Information";
extern bool      show_dots=true;
extern bool      show_also_notrade_dots=false;
extern bool      enable_alerts=true;

double longT[];
double shortT[];
double notrade[];
double longdot[];
double shortdot[];
double notradedot[];

int init() {

   ArrayInitialize(longT,0);
   SetIndexBuffer(0,longT);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexEmptyValue(0,0);

   ArrayInitialize(shortT,0);
   SetIndexBuffer(1,shortT);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);
   SetIndexEmptyValue(1,0);

   ArrayInitialize(notrade,0);
   SetIndexBuffer(2,notrade);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1);
   SetIndexEmptyValue(2,0);  

   ArrayInitialize(longdot,0);
   SetIndexBuffer(3,longdot);
   SetIndexStyle(3,DRAW_ARROW,0,1);
   SetIndexArrow(3,108);
   SetIndexEmptyValue(3,0);  

   ArrayInitialize(shortdot,0);
   SetIndexBuffer(4,shortdot);
   SetIndexStyle(4,DRAW_ARROW,0,1);
   SetIndexArrow(4,108);
   SetIndexEmptyValue(4,0);  

   ArrayInitialize(notradedot,0);
   SetIndexBuffer(5,notradedot);
   SetIndexStyle(5,DRAW_ARROW,0,1);
   SetIndexArrow(5,108);
   SetIndexEmptyValue(5,0);  

   return(0);
}

int start() {



 double pt=MarketInfo(Symbol(),MODE_POINT);
   int    counted_bars=IndicatorCounted();
   int i=Bars-counted_bars-1;   
   
   while(i>0)
   {  
      double ma1=iMA(NULL,0,ma_period_1,ma_shift_1,ma_method_1,ma_price_1,i);
      double ma2=iMA(NULL,0,ma_period_2,ma_shift_2,ma_method_2,ma_price_2,i);
      double ma1p=iMA(NULL,0,ma_period_1,ma_shift_1,ma_method_1,ma_price_1,i+1);
      double ma2p=iMA(NULL,0,ma_period_2,ma_shift_2,ma_method_2,ma_price_2,i+1);
   


   

   if(ma1>=ma2+deviation*pt) {
    longT[i]=ma2;
    longT[i+1]=ma2p;
    if(longT[i+2]==0 && show_dots) {
     longdot[i+1]=ma2p;
     if(i==1) {
       if(enable_alerts) Alert("ftcl: Buy signal on " + Symbol() + ", " + Period());
     }
    }
   } else {
    longT[i]=0;
   }

   if(ma1<=ma2-deviation*pt) {
    shortT[i]=ma2;
    shortT[i+1]=ma2p;
    if(shortT[i+2]==0 && show_dots) {
     shortdot[i+1]=ma2p;
     if(i==1) {
       if(enable_alerts)Alert("ftcl: Sell signal on " + Symbol() + "," + Period());
     }
    }
    
   } else {
    shortT[i]=0;
   }
   
   if(ma1<ma2+deviation*pt && ma1>ma2-deviation*pt) {
    notrade[i]=ma2;
    notrade[i+1]=ma2p;
    if(notrade[i+2]==0 && show_dots && show_also_notrade_dots) {
     notradedot[i+1]=ma2p;
    }
   } else {
    notrade[i]=0;
   }
      i--;
  }
   
   return(0);
}

